//////////////////////////////////////////////
// Global variables
//////////////////////////////////////////////
float4x4 	g_vlp;

//////////////////////////////////////////////
//	VS_INPUT/OUTPUT
//////////////////////////////////////////////
struct VS_INPUT{
	float3 Pos	: POSITION;
};

struct VS_OUTPUT{
	float4 Pos	: POSITION;
	float4 Depth: TEXCOORD0;
};
//////////////////////////////////////////////
//	PS_INPUT/OUTPUT
//////////////////////////////////////////////
struct PS_INPUT{
	float4 Depth: TEXCOORD0;
};

//////////////////////////////////////////////
// Vertex shader
//////////////////////////////////////////////
VS_OUTPUT BasicShadowBufVS(VS_INPUT In)
{	
	VS_OUTPUT Out = (VS_OUTPUT)0;
	
	//vertex trans
	Out.Pos = mul(float4(In.Pos,1.0f), g_vlp);

	//depth
	Out.Depth  = Out.Pos;
	
	return Out;
}


//////////////////////////////////////////////
// Pixel shader
//////////////////////////////////////////////
float4 BasicShadowBufPS(float4 in_depth : TEXCOORD0):COLOR
{
	float4 color;
	float work;
	
	float maxDepth = 2000.0f;
	float baseDepth = 16000.0f - maxDepth;

	//Color
	if( in_depth.z < baseDepth ){
		in_depth.z = 1.0f;
	}else{
		in_depth.z = in_depth.z - baseDepth;
	}
	work = in_depth.z/maxDepth;
	color = float4(work,work,work,1.0f);
	return color;
}

//////////////////////////////////////////////
// Pixel shader
//////////////////////////////////////////////
technique technique0
{
    pass P0
    {
        VertexShader = compile vs_2_0 BasicShadowBufVS();
        PixelShader  = compile ps_2_0 BasicShadowBufPS();
	}
}
